Index: /trunk/src/org/expeditee/gui/FrameKeyboardActions.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameKeyboardActions.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameKeyboardActions.java	(revision 1102)
@@ -19,11 +19,8 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Rectangle;
 import java.awt.Toolkit;
 import java.awt.datatransfer.StringSelection;
 import java.awt.event.KeyEvent;
 import java.awt.event.KeyListener;
-import java.awt.geom.Point2D;
 import java.text.NumberFormat;
 import java.util.ArrayList;
@@ -37,4 +34,7 @@
 import org.expeditee.actions.Navigation;
 import org.expeditee.actions.Simple;
+import org.expeditee.core.AxisAlignedBoxBounds;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Point;
 import org.expeditee.gui.indirect.keyboard.IndirectKeyboardActions;
 import org.expeditee.gui.indirect.keyboard.KeyboardAction;
@@ -51,7 +51,7 @@
 import org.expeditee.items.XRayable;
 import org.expeditee.items.MagneticConstraint.MagneticConstraints;
-import org.expeditee.items.widgets.InteractiveWidget;
+/*import org.expeditee.items.widgets.InteractiveWidget; TODO: Reinstate. cts16
 import org.expeditee.items.widgets.WidgetCorner;
-import org.expeditee.items.widgets.WidgetEdge;
+import org.expeditee.items.widgets.WidgetEdge;*/
 import org.expeditee.settings.experimental.ExperimentalFeatures;
 import org.expeditee.settings.templates.TemplateSettings;
@@ -60,10 +60,10 @@
 import org.expeditee.stats.SessionStats;
 
-public class FrameKeyboardActions implements KeyListener {
+public class FrameKeyboardActions {
 
 	private static FrameKeyboardActions _instance = new FrameKeyboardActions();
 
 	protected FrameKeyboardActions() {
-		IndirectKeyboardActions.getInstance().setDropDownAction(
+		/*IndirectKeyboardActions.getInstance().setDropDownAction(
 				new KeyboardAction() {
 					@Override
@@ -82,9 +82,8 @@
 						} else {
 							// Move to the top of the box
-							Rectangle rect = info.firstConnected
-									.getEnclosedShape().getBounds();
-							int newX = rect.x + Text.MARGIN_LEFT;
+							AxisAlignedBoxBounds rect = info.firstConnected.getBounds();
+							int newX = rect.getMinX() + Text.MARGIN_LEFT;
 							int newY = Text.MARGIN_LEFT
-									+ rect.y
+									+ rect.getMinY()
 									+ DisplayIO.getCurrentFrame()
 											.getItemTemplate()
@@ -171,5 +170,5 @@
 						return null;
 					}
-				});
+				});*/
 		IndirectKeyboardActions.getInstance().setCreateNewTextAction(
 				new KeyboardAction() {
@@ -179,8 +178,6 @@
 								"" + c);
 
-						Point2D.Float newMouse = t.insertChar(c,
-								DisplayIO.getMouseX(), FrameMouseActions.getY());
-						DisplayIO.setCursorPosition(newMouse.x, newMouse.y,
-								false);
+						Point newMouse = t.insertChar(c, DisplayIO.getMouseX(), FrameMouseActions.getY());
+						DisplayIO.setCursorPosition(newMouse.x, newMouse.y, false);
 
 						return t;
@@ -192,5 +189,5 @@
 					public Text exec(final KeyboardInfo info, final char c) {
 						float oldY = FrameMouseActions.MouseY;
-						Point2D.Float newMouse = null;
+						Point newMouse = null;
 						if (c == '\t') {
 							if (info.isShiftDown) {
@@ -212,5 +209,5 @@
 							// float diff = newMouse.y - oldY;
 							// System.out.print("c");
-							Rectangle rect = info.firstConnected.getPolygon().getBounds();
+							AxisAlignedBoxBounds rect = info.firstConnected.getBounds();
 
 							// Text lastEdited = FrameUtils.getLastEdited();
@@ -218,5 +215,5 @@
 
 							Item justBelow = FrameUtils.onItem(DisplayIO.getCurrentFrame(),
-									info.firstConnected.getX() + 10, rect.y + rect.height + 1, false);
+									info.firstConnected.getX() + 10, rect.getMinY() + rect.getHeight() + 1, false);
 
 							// FrameUtils.setLastEdited(lastEdited);
@@ -242,16 +239,7 @@
 	}
 
-	private static Text _toRemove = null;
-
-	private static Collection<Item> _enclosedItems = null;
-
-	public static void resetEnclosedItems() {
-		_enclosedItems = null;
-	}
-
 	public synchronized void keyTyped(KeyEvent e) {
 		if (Simple.isProgramRunning()) {
-			if (e.isControlDown()
-					&& (e.getKeyChar() == KeyEvent.VK_ESCAPE || e.getKeyChar() == KeyEvent.VK_C)) {
+			if (e.isControlDown() && (e.getKeyChar() == KeyEvent.VK_ESCAPE || e.getKeyChar() == KeyEvent.VK_C)) {
 				Simple.stop();
 				return;
@@ -262,6 +250,6 @@
 				Simple.KeyStroke(e.getKeyChar());
 			}
-			if (Simple.consumeKeyboardInput())
-				return;
+			
+			if (Simple.consumeKeyboardInput()) return;
 		}
 
@@ -284,224 +272,6 @@
 		// System.out.println(ch);
 
-		if (e.isAltDown()) {
-
-		} else {
-			processChar(ch, e.isShiftDown());
-		}
+		if (!e.isAltDown()) processChar(ch, e.isShiftDown());
 		// FrameGraphics.Repaint();
-	}
-
-	public static void processChar(char ch, boolean isShiftDown) {
-		Navigation.ResetLastAddToBack();
-		Item on = FrameUtils.getCurrentItem();
-
-		// permission check
-		if (on != null && !on.hasPermission(UserAppliedPermission.full)) {
-			MessageBay
-					.displayMessage("Insufficient permission to edit this item");
-			return;
-		}
-
-		if (isShiftDown && MagneticConstraints.getInstance().keyHit(-ch, on))
-			return;
-		else if (MagneticConstraints.getInstance().keyHit(ch, on))
-			return;
-
-		if (_toRemove != null && on != _toRemove) {
-			assert (_toRemove.getLength() == 0);
-			// This line is to protect mistaken removal of items if there is a
-			// bug...
-			if (_toRemove.getLength() == 0)
-				DisplayIO.getCurrentFrame().removeItem(_toRemove);
-		}
-		_toRemove = null;
-
-		// ignore delete and backspace if in free space
-		if ((on == null || !(on instanceof Text))
-				&& (ch == KeyEvent.VK_BACK_SPACE || ch == KeyEvent.VK_TAB || ch == KeyEvent.VK_DELETE))
-			return;
-
-		SessionStats.TypedChar(ch);
-
-		// check for dot's being replaced with text
-		if (on != null && on instanceof Dot && !(on instanceof WidgetCorner)) {
-			if (ch == KeyEvent.VK_BACK_SPACE || ch == KeyEvent.VK_DELETE) {
-				return;
-			}
-			replaceDot((Item) on, ch);
-			return;
-		}
-
-		// only text can interact with keyboard events
-		if (on != null && !(on instanceof Text))
-			on = null;
-
-		// DisplayIO.UpdateTitle();
-
-		Text text = (Text) on;
-		// if this text is empty but has not been removed (such as from
-		// ESC-pushdown)
-		if (text != null && text.isEmpty()
-				&& (ch == KeyEvent.VK_BACK_SPACE || ch == KeyEvent.VK_DELETE)) {
-			if (text.getLines().size() > 0)
-				replaceText(text);
-			else {
-				DisplayIO.setCursor(Item.DEFAULT_CURSOR);
-			}
-			return;
-		}
-
-		// if the user is in free space, create a new text item
-		/*
-		 * MikeSays: Why do we have to check is highlighted... doing so causes
-		 * problems if you type characters to fast, they turn into multiple text
-		 * items. ie. JK together on the Linux laptop.
-		 */
-		if (on == null /* || !on.isHighlighted() */) {
-			// DisplayIO.UpdateTitle();
-			text = createText(ch);
-			text.justify(false);
-
-			FrameUtils.setLastEdited(text);
-			DisplayIO.setTextCursor(text, Text.NONE);
-			return;
-		} else {
-			FrameUtils.setLastEdited(text);
-		}
-
-		DisplayIO.setTextCursor(text, Text.NONE);
-		IndirectKeyboardActions.getInstance().getInsertCharacterAction()
-				.exec(new KeyboardInfo(null, ch, isShiftDown, isShiftDown,
-						_enclosedItems, text, _enclosedItems, _enclosedItems), ch);
-
-		// This repaint is needed for WINDOWS only?!?!? Mike is not sure why!
-		if (ch == KeyEvent.VK_DELETE)
-			FrameGraphics.requestRefresh(true);
-
-		// a change has occured to the Frame
-		text.getParent().setChanged(true);
-
-		// check that the Text item still exists (hasn't been deleted\backspaced
-		// away)
-		if (text.isEmpty()) {
-			_toRemove = text;
-
-			if (text.hasAction())
-				text.setActionMark(true);
-			else if (text.getLink() != null)
-				text.setLinkMark(true);
-			else if (text.getLines().size() > 0)
-				replaceText(text);
-			else {
-				// DisplayIO.getCurrentFrame().removeItem(text);
-				DisplayIO.setCursor(Item.DEFAULT_CURSOR);
-			}
-		}
-	}
-
-	public static Text replaceDot(Item dot, char ch) {
-		Text text = createText(ch);
-		Item.DuplicateItem(dot, text);
-		FrameUtils.setLastEdited(text);
-
-		// Copy the lines list so it can be modified
-		List<Line> lines = new LinkedList<Line>(dot.getLines());
-		for (Line line : lines)
-			line.replaceLineEnd(dot, text);
-		Frame current = dot.getParentOrCurrentFrame();
-		current.removeItem(dot);
-		ItemUtils.EnclosedCheck(current.getItems());
-		return text;
-	}
-
-	/**
-	 * Replaces the given text item with a dot
-	 */
-	public static Item replaceText(Item text) {
-		Item dot = new Dot(text.getX(), text.getY(), text.getID());
-		Item.DuplicateItem(text, dot);
-
-		List<Line> lines = new LinkedList<Line>();
-		lines.addAll(text.getLines());
-		if (lines.size() > 0)
-			dot.setColor(lines.get(0).getColor());
-		for (Line line : lines) {
-			line.replaceLineEnd(text, dot);
-		}
-		text.delete();
-		Frame current = text.getParentOrCurrentFrame();
-		current.addItem(dot);
-		DisplayIO.setCursor(Item.DEFAULT_CURSOR);
-		ItemUtils.EnclosedCheck(current.getItems());
-		return dot;
-	}
-
-	/**
-	 * Creates a new Text Item whose text contains the given character. This
-	 * method also moves the mouse cursor to be pointing at the newly created
-	 * Text Item ready to insert the next character.
-	 * 
-	 * @param start
-	 *            The character to use as the initial text of this Item.
-	 * @return The newly created Text Item
-	 */
-	private static Text createText(char start) {
-		return IndirectKeyboardActions.getInstance().getCreateNewTextAction()
-				.exec(new KeyboardInfo(null, start, false, false, _enclosedItems, _toRemove, _enclosedItems, _enclosedItems), start);
-	}
-
-	/**
-	 * Creates a new Text Item with no text. The newly created Item is a copy of
-	 * any ItemTemplate if one is present, and inherits all the attributes of
-	 * the Template
-	 * 
-	 * @return The newly created Text Item
-	 */
-	private static Text createText() {
-		return DisplayIO.getCurrentFrame().createNewText();
-	}
-
-	private void move(int direction, boolean isShiftDown, boolean isCtrlDown) {
-		Item on = FrameUtils.getCurrentItem();
-
-		if ((on == null) || (on instanceof Picture)){
-			navigateFrame(direction);
-			return;
-		}
-
-		if (on instanceof Text) {
-			Text text = (Text) on;
-			// When the user hits the left and right button with mouse
-			// positions over the the frame name navigation occurs
-			if (text.isFrameName()) {
-				navigateFrame(direction);
-				return;
-			} else {
-				FrameUtils.setLastEdited(text);
-				DisplayIO.setTextCursor(text, direction, false, isShiftDown,
-						isCtrlDown, true);
-			}
-		}
-	}
-
-	private void navigateFrame(int direction) {
-		switch (direction) {
-		case Text.RIGHT:
-		case Text.PAGE_UP:
-			Navigation.NextFrame(false);
-			break;
-		case Text.LEFT:
-		case Text.PAGE_DOWN:
-			Navigation.PreviousFrame(false);
-			break;
-		case Text.HOME:
-		case Text.LINE_HOME:
-			Navigation.ZeroFrame();
-			break;
-		case Text.END:
-		case Text.LINE_END:
-			Navigation.LastFrame();
-			break;
-		}
 	}
 
@@ -515,13 +285,18 @@
 		int keyCode = e.getKeyCode();
 
-		if (keyCode != KeyEvent.VK_F1 && keyCode != KeyEvent.VK_F2) {
+		// Empty the list of enclosed items if not a size-up or size-down press
+/*		if (keyCode != KeyEvent.VK_F1 && keyCode != KeyEvent.VK_F2) {
 			resetEnclosedItems();
 		}
 
+		// Notify the change in stats
+		// TODO: Will changing this to the Expeditee KBMInputEvent upset stats? cts16
 		SessionStats.AddFrameEvent("k" + KeyEvent.getKeyText(keyCode));
 
+		// Used for calculating frame stats (response time)
 		FrameUtils.ResponseTimer.restart();
 		// e.consume();
 
+		// Things that should consume input before main Expeditee
 		if (Actions.isAgentRunning()) {
 			if (keyCode == KeyEvent.VK_ESCAPE)
@@ -534,9 +309,13 @@
 		}
 
+		// Function keys are handled here
 		if (keyCode >= KeyEvent.VK_F1 && keyCode <= KeyEvent.VK_F12) {
-			functionKey(FunctionKey.values()[keyCode - KeyEvent.VK_F1 + 1],
-					e.isShiftDown(), e.isControlDown());
-			return;
-		} else if (e.isAltDown()) {
+			functionKey(FunctionKey.values()[keyCode - KeyEvent.VK_F1 + 1], e.isShiftDown(), e.isControlDown());
+			return;
+		}*/
+		
+		// Keyboard for mouse emulation
+		// TODO: Do we need individual mouse button clicks? Are the corresponding gestures enough? cts16
+		if (e.isAltDown()) {
 			int distance = e.isShiftDown() ? 1 : 20;
 			switch (keyCode) {
@@ -553,5 +332,5 @@
 				FrameMouseActions.rightButton();
 				break;
-			case KeyEvent.VK_LEFT:
+/*			case KeyEvent.VK_LEFT:
 				DisplayIO.translateCursor(-distance, 0);
 				break;
@@ -564,8 +343,10 @@
 			case KeyEvent.VK_DOWN:
 				DisplayIO.translateCursor(0, distance);
-				break;
-			}
-			return;
-		}
+				break;*/
+			}
+			return;
+		}
+		
+		// Notify the mouse handler of the control/shift key state
 		switch (keyCode) {
 		case KeyEvent.VK_CONTROL:
@@ -577,4 +358,5 @@
 		}
 
+		// Handles all CTRL+KEY combinations
 		if (e.isControlDown()) {
 			controlChar(e.getKeyCode(), e.isShiftDown());
@@ -582,16 +364,17 @@
 		}
 
-		switch (keyCode) {
+		// Handles all other keystrokes (with possible shift modifier)
+		// Note: At this point e.isControlDown() must be false
+/*		switch (keyCode) {
 		case KeyEvent.VK_ESCAPE:
-			// Do escape after control so Ctl+Escape does not perform DropDown
-			functionKey(FunctionKey.DropDown, e.isShiftDown(),
-					e.isControlDown());
+			// Do escape after control so Ctrl+Escape does not perform DropDown
+			functionKey(FunctionKey.DropDown, e.isShiftDown(), false);
 			SessionStats.Escape();
 			break;
 		case KeyEvent.VK_LEFT:
-			move(Text.LEFT, e.isShiftDown(), e.isControlDown());
+			move(Text.LEFT, e.isShiftDown(), false);
 			break;
 		case KeyEvent.VK_RIGHT:
-			move(Text.RIGHT, e.isShiftDown(), e.isControlDown());
+			move(Text.RIGHT, e.isShiftDown(), false);
 			break;
 		case KeyEvent.VK_PAGE_DOWN:
@@ -602,28 +385,14 @@
 			break;
 		case KeyEvent.VK_UP:
-			if (e.isControlDown()) {
-				NextTextItem(FrameUtils.getCurrentItem(), false);
-			} else {
-				move(Text.UP, e.isShiftDown(), e.isControlDown());
-			}
+			move(Text.UP, e.isShiftDown(), false);
 			break;
 		case KeyEvent.VK_DOWN:
-			if (e.isControlDown()) {
-				NextTextItem(FrameUtils.getCurrentItem(), true);
-			} else {
-				move(Text.DOWN, e.isShiftDown(), e.isControlDown());
-			}
+			move(Text.DOWN, e.isShiftDown(), false);
 			break;
 		case KeyEvent.VK_END:
-			if (e.isControlDown())
-				move(Text.END, e.isShiftDown(), e.isControlDown());
-			else
-				move(Text.LINE_END, e.isShiftDown(), e.isControlDown());
+			move(Text.LINE_END, e.isShiftDown(), false);
 			break;
 		case KeyEvent.VK_HOME:
-			if (e.isControlDown())
-				move(Text.HOME, e.isShiftDown(), e.isControlDown());
-			else
-				move(Text.LINE_HOME, e.isShiftDown(), e.isControlDown());
+			move(Text.LINE_HOME, e.isShiftDown(), false);
 			break;
 		// TODO remove this when upgrading Java
@@ -636,85 +405,5 @@
 			}
 			break;
-		}
-	}
-
-	/**
-	 * Moves the cursor to the next text item on the frame
-	 * 
-	 * @param currentItem
-	 * @param direction
-	 *            move up if direction is negative, down if direction is
-	 *            positive
-	 */
-	public static void NextTextItem(Item currentItem, boolean down) {
-		// Move the cursor to the next text item
-		Frame current = DisplayIO.getCurrentFrame();
-		Text title = current.getTitleItem();
-
-		Collection<Text> currentItems = FrameUtils.getCurrentTextItems();
-		List<Text> textItems = new ArrayList<Text>();
-		// Move to the next text item in the box if
-		if (currentItems.contains(currentItem)) {
-			textItems.addAll(currentItems);
-		} else {
-			if (title != null)
-				textItems.add(title);
-			textItems.addAll(current.getBodyTextItems(true));
-		}
-
-		Collections.sort(textItems);
-
-		if (textItems.size() == 0) {
-			// If there are no text items on the frame its a NoOp
-			if (title == null)
-				return;
-			if (title != null)
-				DisplayIO.MoveCursorToEndOfItem(title);
-			FrameGraphics.Repaint();
-			return;
-		}
-
-		// If the user is mouse wheeling in free space...
-		if (currentItem == null) {
-			// find the nearest item in the correct direction
-			int currY = FrameMouseActions.getY();
-			for (int i = 0; i < textItems.size(); i++) {
-				Item t = textItems.get(i);
-				if (currY < t.getY()) {
-					if (down) {
-						DisplayIO.MoveCursorToEndOfItem(t);
-					} else {
-						if (i == 0) {
-							DisplayIO.MoveCursorToEndOfItem(current
-									.getTitleItem());
-						} else {
-							DisplayIO.MoveCursorToEndOfItem(textItems
-									.get(i - 1));
-						}
-					}
-					FrameGraphics.Repaint();
-					return;
-				}
-			}
-			// If we are at the botton of the screen and the user scrolls down
-			// then scroll backup to the title
-			if (textItems.size() > 0) {
-				DisplayIO
-						.MoveCursorToEndOfItem(textItems.get(textItems.size() - 1));
-			}
-			return;
-		}
-
-		// Find the current item... then move to the next item
-		int i = textItems.indexOf(currentItem);
-
-		int nextIndex = i + (down ? 1 : -1);
-		if (nextIndex >= 0 && nextIndex < textItems.size()) {
-			DisplayIO.MoveCursorToEndOfItem(textItems.get(nextIndex));
-		} else {
-			DisplayIO.MoveCursorToEndOfItem(currentItem);
-		}
-		return;
-
+		}*/
 	}
 
@@ -739,20 +428,4 @@
 	}
 
-	private static void copyItemToClipboard(Item on) {
-		if (on == null || !(on instanceof Text))
-			return;
-
-		Text text = (Text) on;
-		String string = text.copySelectedText();
-
-		if (string == null || string.length() == 0)
-			string = text.getText();
-
-		// add the text of the item to the clipboard
-		StringSelection selection = new StringSelection(string);
-		Toolkit.getDefaultToolkit().getSystemClipboard()
-				.setContents(selection, null);
-	}
-
 	/**
 	 * Processes all control character keystrokes. Currently Ctrl+C and Ctrl+V
@@ -763,6 +436,5 @@
 	 */
 	private void controlChar(int key, boolean isShiftDown) {
-		Logger.Log(Logger.USER, Logger.CONTROL_CHAR, "User pressing: Ctrl+"
-				+ KeyEvent.getKeyText(key));
+		//Logger.Log(Logger.USER, Logger.CONTROL_CHAR, "User pressing: Ctrl+" + KeyEvent.getKeyText(key));
 		//
 		// if (FrameUtils.getCurrentItem() == null
@@ -776,5 +448,5 @@
 		int distance = isShiftDown ? 1 : 20;
 		switch (key) {
-		case KeyEvent.VK_HOME:
+/*		case KeyEvent.VK_HOME:
 			if (current != null && current instanceof Text) {
 				move(Text.HOME, isShiftDown, true);
@@ -802,7 +474,7 @@
 			break;
 		case KeyEvent.VK_ESCAPE:
-			// Do escape after control so Ctl+Escape does not perform DropDown
+			// Do escape after control so Ctrl+Escape does not perform DropDown
 			functionKey(FunctionKey.DropDown, isShiftDown, true);
-			SessionStats.Escape();
+			SessionStats.Escape();*/
 			break;
 		case KeyEvent.VK_1:
@@ -819,20 +491,18 @@
 			break;
 		case KeyEvent.VK_LEFT:
-			if (current instanceof Text) {
-				DisplayIO.setTextCursor((Text) current, Text.LEFT, false,
-						isShiftDown, true, true);
-			} else {
+/*			if (current instanceof Text) {
+				DisplayIO.setTextCursor((Text) current, Text.LEFT, false, isShiftDown, true, true);
+			} else */{
 				DisplayIO.translateCursor(-distance, 0);
 			}
 			break;
 		case KeyEvent.VK_RIGHT:
-			if (current instanceof Text) {
-				DisplayIO.setTextCursor((Text) current, Text.RIGHT, false,
-						isShiftDown, true, true);
-			} else {
+/*			if (current instanceof Text) {
+				DisplayIO.setTextCursor((Text) current, Text.RIGHT, false, isShiftDown, true, true);
+			} else */{
 				DisplayIO.translateCursor(distance, 0);
 			}
 			break;
-		case KeyEvent.VK_UP:
+/*		case KeyEvent.VK_UP:
 			// if (current instanceof Text) {
 			NextTextItem(FrameUtils.getCurrentItem(), false);
@@ -849,5 +519,5 @@
 			break;
 		case KeyEvent.VK_L:
-			// If its not linked then link it to its self
+			// If its not linked then link it to itself
 			if (current instanceof Text && current.getLink() == null) {
 				String text = ((Text) current).getText();
@@ -866,6 +536,6 @@
 			}
 			break;
-		case KeyEvent.VK_G:
-			// If its not linked then link it to its self
+		case KeyEvent.VK_G: // Same as CTRL+L but follows it afterwards
+			// If its not linked then link it to itself
 			if (current instanceof Text) {
 				String text = ((Text) current).getText();
@@ -922,5 +592,5 @@
 			return;
 		case KeyEvent.VK_C:
-			if (FreeItems.itemsAttachedToCursor()) {
+			if (FreeItems.hasItemsAttachedToCursor()) {
 				ItemSelection.copyClone();
 				return;
@@ -933,6 +603,5 @@
 			if (current instanceof Dot && current.getLines().size() == 1) {
 				item = replaceDot(current, '@');
-			} else if (current instanceof Line
-					&& current.getAllConnected().size() == 3) {
+			} else if (current instanceof Line && current.getAllConnected().size() == 3) {
 				Item end = ((Line) current).getEndItem();
 				if (end instanceof Dot) {
@@ -955,12 +624,9 @@
 			if (current == null)
 				return;
-			if (current != null
-					&& !current.hasPermission(UserAppliedPermission.full)) {
-				MessageBay
-						.displayMessage("Insufficient permission toggle the items mark");
-				return;
-			}
-			boolean newValue = !(current.getLinkMark() || current
-					.getActionMark());
+			if (current != null && !current.hasPermission(UserAppliedPermission.full)) {
+				MessageBay.displayMessage("Insufficient permission toggle the items mark");
+				return;
+			}
+			boolean newValue = !(current.getLinkMark() || current.getActionMark());
 			current.setLinkMark(newValue);
 			current.setActionMark(newValue);
@@ -980,5 +646,5 @@
 			// perform a delete operation
 			FrameMouseActions.delete(current);
-			break;
+			break;*/
 		case KeyEvent.VK_SPACE:
 			if (isShiftDown) {
@@ -988,5 +654,5 @@
 			}
 			break;
-		case KeyEvent.VK_F:
+/*		case KeyEvent.VK_F:
 			// perform a format operation
 			if (isShiftDown) {
@@ -1012,5 +678,5 @@
 			break;
 
-		case KeyEvent.VK_R:
+		case KeyEvent.VK_R: // TODO: What is this? Similar to above? cts16
 			Text textCurrent = getCurrentTextItem();
 			if (textCurrent == null) {
@@ -1026,10 +692,8 @@
 			break;
 		case KeyEvent.VK_S:
-			/*
-			 * Only split when shift is down... it is too easy to accidentally
-			 * hit Ctrl+S after completing a paragraph because this is the
-			 * shortcut for saving a document in most word processors and text
-			 * editors!
-			 */
+			// Only split when shift is down... it is too easy to accidentally
+			// hit Ctrl+S after completing a paragraph because this is the
+			// shortcut for saving a document in most word processors and text
+			// editors!
 			if (!isShiftDown) {
 				Save();
@@ -1057,11 +721,11 @@
 				currentFrame.addItem(newText);
 			}
-			break;
+			break;*/
 		case KeyEvent.VK_ENTER:
 			FrameMouseActions.leftButton();
 			break;
-		case KeyEvent.VK_BACK_SPACE:
+/*		case KeyEvent.VK_BACK_SPACE:
 			DisplayIO.Back();
-			break;
+			break;*/
 		}
 		FrameGraphics.Repaint();
@@ -1078,6 +742,5 @@
 
 		if (item != null && !item.hasPermission(UserAppliedPermission.full)) {
-			MessageBay
-					.displayMessage("Insufficient permission to copy that item");
+			MessageBay.displayMessage("Insufficient permission to copy that item");
 			return null;
 		}
@@ -1093,15 +756,15 @@
 	}
 
-	public static void functionKey(FunctionKey key, boolean isShiftDown,
-			boolean isControlDown) {
+/*	public static void functionKey(FunctionKey key, boolean isShiftDown, boolean isControlDown)
+	{
 		functionKey(key, 1, isShiftDown, isControlDown);
 	}
-
+*/
 	/**
 	 * Called when a Function key has been pressed, and performs the specific
 	 * action based on the key.
 	 */
-	public static void functionKey(FunctionKey key, int repeat,
-			boolean isShiftDown, boolean isControlDown) {
+/*	public static void functionKey(FunctionKey key, int repeat, boolean isShiftDown, boolean isControlDown)
+	{
 		// get whatever the user is pointing at
 		Item on = FrameUtils.getCurrentItem();
@@ -1195,18 +858,19 @@
 			}
 		}
+				
 		// Show a description of the function key pressed if the user is in free
 		// space and return for the F keys that dont do anything in free space.
 		if (on == null) {
 			
-			int mouse_x = FrameMouseActions.getX(), mouse_y = FrameMouseActions.getY();
+			// int mouse_x = FrameMouseActions.getX(), mouse_y = FrameMouseActions.getY();
 			
 			switch (key) {
 			// These function keys still work in free space
-			case DropDown:
-			case InsertDate:
+//			case DropDown:
+//			case InsertDate:
 			case XRayMode:
 			case AudienceMode:
 			case Refresh:
-			case Save:
+//			case Save:
 				break;
 				
@@ -1244,11 +908,10 @@
 				}
 			}
-			Drop(on, false);
+//			Drop(on, false);
 			return;
 		case SizeUp:
 			SetSize(on, repeat, true, false, isControlDown);
 			if (on instanceof Text) {
-				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false,
-						false, true);
+				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false, false, true);
 			}
 			break;
@@ -1256,6 +919,5 @@
 			SetSize(on, -repeat, true, false, isControlDown);
 			if (on instanceof Text) {
-				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false,
-						false, true);
+				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false, false, true);
 			}
 			break;
